var g_replayAction = new Array()
var g_currentScene = null

function buildAction(subActionType, offsetTime, detail) {
    var obj = JSON.parse(detail)
    return {
        "actionType": subActionType,
        "offsetTime": offsetTime,
        "detail": obj
    }
}

function getReplayActionType(type) {
    switch (type) {
        case "asr":
        return "ASRAndJudgeReplayAction_"
        case "circle":
        return "CircleReplayAction_"
        case "match":
        return "MatchReplayAction_"
        case "match_done":
        return "MatchWithDoneReplayAction_"
        case "purble":
        return "PurbleReplayAction_"
        case "letter":
        return "LetterReplayAction_"
        case "audioMatch":
        return "AudioMutiMatchReplayAction_"
        case "errorCorrection":
        return "ChooseWrongWordsReplayAction_"
        case "chooseWords":
        return "ChooseRightWordsReplayAction_"
    }
}

function buildTimeline(key) {
    var rootAction = {
        "actionsID": "0",
        "actions": []
    }
    var nodes = [rootAction]
    var links = []
    for (var i = 0; i < g_replayAction[key].length; i ++) {
        var node = {}
        node.actionsID = i + 1
        node.actions = new Array()
        node.actions.push(g_replayAction[key][i])
        nodes.push(node)

        var source = 0
        var target =  node.actionsID
        var delay = parseInt(g_replayAction[key][i].offsetTime * 1000)
        var link = {
            "source": source,
            "target": target,
            "delay": delay
        }
        links.push(link)
    }
    return {
        "nodes": nodes,
        "links": links
    } 
}

function buildReplayAction(jsonPath,key, type) {
    var oldAction = {}
    var path = "g_currentScene" + jsonPath
    console.log(jsonPath)
    eval("oldAction="+path)
    oldAction.actionType = getReplayActionType(type)
    oldAction.detail.timeline = buildTimeline(key)
}

function setScene(scene) {
    var _scene = JSON.parse(scene)
    g_currentScene = _scene
}

function cleanScene() {
    g_currentScene = null
}

function getScene() {
    return JSON.stringify(g_currentScene)
}

function begin() {
    _actionsMap = new Object()
}

function add(key, subActionType, offsetTime, detail) {
    var subAction = buildAction(subActionType, offsetTime, detail)
    if (g_replayAction[key] == null) {
        g_replayAction[key] = new Array()
    }
    g_replayAction[key].push(subAction)
    return g_replayAction[key].length
}

function getSize(key){
    if(g_replayAction[key] == null){
        return 1
    }
    if (g_replayAction[key].length == 0){
    return 1
    }
    return g_replayAction[key].length
}

function commit(jsonPath,key, type) {
    buildReplayAction(jsonPath,key, type)
    g_replayAction = new Array()
}

// begin()

// add(".timeline.nodes[3].actions[0].detail.timeline.nodes[1].actions[0]", "gg", 100, "{}")
// add(".timeline.nodes[3].actions[0].detail.timeline.nodes[1].actions[0]", "dd", 200, "{}")
// add(".timeline.nodes[3].actions[0].detail.timeline.nodes[1].actions[0]", "ww", 300, "{}")

// commit(".timeline.nodes[3].actions[0].detail.timeline.nodes[1].actions[0]", "asr")
// console.log("%j", g_currentScene)
